> For the complete documentation index, see [llms.txt](https://docs.reflexer.finance/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.reflexer.finance/system-contracts/oracle-module/fsm/fsm-governance-interface.md).

# FSM Governance Interface

## 1. Summary

This governance interface allows token holders to `stop()` FSM-like contracts in case of an oracle attack.

## 2. Contract Variables & Functions <a href="#id-2-contract-details" id="id-2-contract-details"></a>

**Variables**

* `owner` - the address of the contract's owner. Meant to set `FSM` addresses
* `onlyOwner` - modifier that checks whether the `owner` calls a function
* `authority` - contract authority, able only to stop an `FSM`
* `fsms[collateralType: bytes32]` - mapping of OSM-like contracts

**Modifiers**

* `isAuthorized` - modifier that checks whether msg.sender can call a specific function
* `onlyOwner` - modifiers that ensures only the `owner` can call a specific function

**Functions**

* `canCall` - checks whether an address can call a function
* `setFsm(bytes32: collateralType, address: fsm)` - set the address of an `FSM` for a specific collateral type
* `setOwner(address: owner]` - change the contract's owner
* `setAuthority(address: authority)` - change the contract's authority
* `stop(bytes32: collateralType)` - stop a collateral type's `FSM`

## 3. Walkthrough <a href="#id-2-contract-details" id="id-2-contract-details"></a>

The `owner` and the `authority` can be changed using `setOwner` and `setAuthority`. The `owner` can `setFsm`s for each collateral type and any authed address (be it the `owner`, `authority` or another address that was whitelisted in the `authority` contract) can `stop` any `FSM`.


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.reflexer.finance/system-contracts/oracle-module/fsm/fsm-governance-interface.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
